;The MASM32 Runtime Floating Point Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include   \masm32\fpulib\fpu.inc
IncludeLib   \masm32\fpulib\fpu.lib
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Const
IDC_EDIT        Equ 3000
IDC_BUTTON      Equ 3001
IDC_EXIT        Equ 3002
IDM_GETTEXT     Equ 32000
IDM_CLEAR       Equ 32001
IDM_EXIT        Equ 32002

.Data?
szBuffer		Byte 1000 Dup(?)  ; buffer to output quadratic and linear formats
                                 ; as well as solutions
szNumber1       Byte  120 Dup (?)
szNumber2       Byte  120 Dup (?)
szNumber3       Byte  120 Dup (?)
szNumberA       Byte  120 Dup (?)
szNumberB       Byte  120 Dup (?)
szNumberC       Byte  120 Dup (?)
szRootX0        Byte  120 Dup (?)
szRootX1        Byte  120 Dup (?)
szLinearRootX   Byte  120 Dup (?)

.Data
szCRLF			Byte 13, 10, 0  ; carriage return and line feed

Number0         Real10  0.0   ; used to determine if there are real roots in the
                              ; quadratic formula
Number2         Real10  2.0   ; number to use to get the denominator in the quadratic
                              ; formula
Number4         Real10  4.0   ; number to get part of the square root number
Minus1          Real10 - 1.0   ; used for negation
; 
NumberA         Real10 ?     ; the coefficient of X^2 in the quadratic equation
NumberB         Real10 ?     ; the coefficient of X in the quadratic equation
NumberC         Real10 ?     ; the constant in the quadratic equation
;------------------------------------
_RootX0         Real10 ?      ; first real root solution to the quadratic formula
_RootX1         Real10 ?      ; second real root solution to the quadratic formula
_LinearRootX    Real10 ?      ; real linear root solution to the linear equation
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Code

QuadraticSolutionsProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_CREATE

		Return TRUE
	.ElseIf uMsg == WM_COMMAND
		LoWord wParam ;Get the low word of wParam
		.If Ax == IDC_QUADRATICSOLUTIONS_SOLVEBUTTON
			HiWord wParam ;Get the high word of wParam
			.If Ax == BN_CLICKED
				;Solve button has been clicked
                Invoke SolveQuadraticEquation, hWnd, uMsg, wParam, lParam
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_QUADRATICSOLUTIONS_CLEARBUTTON
			HiWord wParam ;Get the high word of wParam
			.If Ax == BN_CLICKED
				;Clear button has been clicked

				;Get the handle for the Edit control
				Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_GETA
				;Set Edit control to no text
				Invoke SetWindowText, Eax, NULL

                ;Get the handle for the Edit control
				Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_GETB
				;Set Edit control to no text
				Invoke SetWindowText, Eax, NULL

                ;Get the handle for the Edit control
				Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_GETC
				;Set Edit control to no text
				Invoke SetWindowText, Eax, NULL

				;Get the handle for the Results static control
				Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_RESULTS
				;Set the Results static control to no text
				Invoke SetWindowText, Eax, NULL

				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_QUADRATICSOLUTIONS_EXITBUTTON
			HiWord wParam ;Get the high word of wParam
			.If Ax == BN_CLICKED
				;Exit button has been clicked
				Invoke SendMessage, hWnd, WM_CLOSE, 0, 0
				Return TRUE
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_CLOSE
		Invoke IsModal, hWnd
		.If Eax
			Invoke EndModal, hWnd, IDCANCEL
			Return TRUE
		.EndIf
	.EndIf
	Return FALSE
QuadraticSolutionsProcedure EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  SolveQuadraticEquation procedure will solve a quadratic equation by getting  <<
;<<  two solutions using the quadratic forumla.                                   <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

SolveQuadraticEquation Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM

	;Get the handle to Results Static control in Eax
	Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_RESULTS

    Push Edi
    Push Edx
    Push Esi
    Push Ebx

	;Clear the Results control
	Invoke SetWindowText, Edi, NULL

	;Clear szbuffer and number buffers
	Mov szBuffer[0], 0
    Mov szNumber1[0], 0
    Mov szNumber2[0], 0
    Mov szNumber3[0], 0
    Mov szNumberA[0], 0
    Mov szNumberB[0], 0
    Mov szNumberC[0], 0
    Mov szRootX0[0], 0
    Mov szRootX1[0], 0
    Mov szLinearRootX[0], 0

    Invoke GetWindowText, Edi, Addr szBuffer, 255
	Invoke SetWindowText, Edi, Addr szBuffer

    ;Get the handle to Solve button in Eax
    Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_GETA

    ;Get the text in the Edit control
    Invoke GetWindowText, Edx, Addr szNumber1, 24
    ;Convert it to a number returned in Eax
;    Invoke Value, Addr szNumber1
    Invoke FpuAtoFL, Addr szNumber1, Addr NumberA, DEST_MEM

    ;Get the handle to Solve button in Eax
    Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_GETB

    ;Get the text in the Edit control
    Invoke GetWindowText, Esi, Addr szNumber2, 24
    ;Convert it to a number returned in Eax
;    Invoke Value, Addr szNumber2
    Invoke FpuAtoFL, Addr szNumber2, Addr NumberB, DEST_MEM

    ;Get the handle to Solve button in Eax
    Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_GETC

    ;Get the text in the Edit control
    Invoke GetWindowText, Ebx, Addr szNumber3, 24
    ;Convert it to a number returned in Eax
;    Invoke Value, Addr szNumber3
    Invoke FpuAtoFL, Addr szNumber3, Addr NumberC, DEST_MEM

    Invoke  FpuComp, Addr NumberA, Offset Number0, SRC1_REAL Or SRC2_REAL
    Or Eax, Eax     ; activate zero flag
    Jz ErrorInComp   ; jump if zero
    ; ------------------------------------
    ; If bit 0 of EAX=1 => NumberA=Number0
    ; ------------------------------------
    Shr Al, 1             ; mov bit 0 to Carry Flag , NumberA = 0
    Jc Linear             ; jump on Carry Flag
    ;
    Invoke calculateXRoots, Addr NumberA, Addr NumberB, Addr NumberC
    Jc ErrorCalc ; jump on Carry Flag

    Cmp Eax, 2  ; compare Eax with 2 , complex roots results
    Je @F  ; jump if equal to 2 forward to @@
    Invoke printTheXRoots, hWnd
;    print chr$(13, 10)
    Jmp Finish

@@:
    Invoke printQuadraticFormat, hWnd
    ;Adds a carriage return/line feed to szBuffer
    Invoke lstrcat, Addr szBuffer, Addr szCRLF
    Invoke lstrcat, Addr szBuffer, TextAddr("  Solutions for the quadratic equation : ")
    ;Adds a carriage return/line feed to szBuffer
    Invoke lstrcat, Addr szBuffer, Addr szCRLF
    Invoke lstrcat, Addr szBuffer, TextAddr(" --------------------------------------------------------")
    ;Adds a carriage return/line feed to szBuffer
    Invoke lstrcat, Addr szBuffer, Addr szCRLF
    Invoke lstrcat, Addr szBuffer, TextAddr(" There are no real solutions for the above quadratic equation!")
    ;print chr$(" There are no real solutions for the quadratic equation: ", 13, 10)

    ;Adds a carriage return/line feed to szBuffer
    Invoke lstrcat, Addr szBuffer, Addr szCRLF
    ;Adds a carriage return/line feed to szBuffer
    Invoke lstrcat, Addr szBuffer, Addr szCRLF

    Invoke lstrcat, Addr szBuffer, TextAddr(" This equation has complex roots!")
;   print chr$(13, 10, " This equation has complex roots! ")
;   print chr$(13, 10, 13, 10) ; two carriage return line feeds to the screen
                               ; exit here
    ;Get the handle to Results Static control in Eax
    Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_RESULTS
    Invoke SetWindowText, Eax, Addr szBuffer

    Jmp Finish

ErrorInComp:
 ;   print chr$(13, 10)
 ;   print chr$(" Error comparing Number A against zero! ", 13, 10, 13, 10)
    Invoke MessageBox, hWnd, TextAddr("Error comparing Number A against zero!"), TextAddr("Quadratic Solutions"), MB_ICONEXCLAMATION Or MB_OK
    Ret

Linear:
    Invoke FpuComp, Addr NumberB, Offset Number0, SRC1_REAL Or SRC2_REAL
    Or Eax, Eax   ; activates zero flag
    Jz ZeroErrors  ; jump if zero
    ; ------------------------------------
    ; If bit 0 of EAX=1 => NumberB=Number0
    ; ------------------------------------
    Shr Al, 1        ; mov bit 0 to Carry Flag , NumberB = 0
    Jc ZeroErrors
    Invoke calculateLinearRoot, Addr NumberB, Addr NumberC
    Invoke printLinearFormat, hWnd
    Jmp Finish

ZeroErrors:
;    print chr$(13, 10)
;    print chr$(" Error, Numbers for A and B are zero! ", 13, 10, 13, 10)
    Invoke MessageBox, hWnd, TextAddr("Error, Numbers for A and B are zero!"), TextAddr("Quadratic Solutions"), MB_ICONEXCLAMATION Or MB_OK
    Ret

ErrorCalc:
    ;  print chr$(13, 10)
    Invoke MessageBox, hWnd, TextAddr("An Error occurred while calculating the roots!"), TextAddr("Quadratic Solutions"), MB_ICONEXCLAMATION Or MB_OK
    ;print chr$(" An Error occured while calculating the roots", 13, 10)
    Ret

Finish:
	Pop Edi
	Pop Edx
	Pop Esi
	Pop Ebx
	Ret

SolveQuadraticEquation EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  printQuadraticFormat procedure will output the quadratic equation with  <<
;<<  the three numbers that the user entered.                                <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

printQuadraticFormat Proc Private hWnd:HWND

      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer

      Invoke lstrcat, Addr szBuffer, TextAddr(" ")
	  ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

;      print chr$(13, 10)
      Invoke lstrcat, Addr szBuffer, TextAddr(" The quadratic equation : ")
;      print chr$("  Solutions for quadratic equation : ", 13, 10)

      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF
      Invoke lstrcat, Addr szBuffer, TextAddr(" -------------------------------------")
;      print chr$("--------------------------------------", 13, 10)

      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF
      Invoke lstrcat, Addr szBuffer, TextAddr(" ")
;      print chr$(" ")
;      Invoke FpuFLtoA, Addr NumberA, 4, Addr szNumber1, SRC1_REAL
;      print ext$ (NumberA, 0, 4) ; display the X^2 coefficient of
                                                ; quadratic equation
                                                ; to 4 decimal places
      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer
	  ;Convert the NumberA value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, Addr NumberA, Eax, ecDecimal

      Invoke lstrcat, Addr szBuffer, TextAddr(" X^2 ")
;      print chr$(" X^2 ")
                     ;
      Invoke FpuComp, Addr NumberB, Offset Number0, SRC1_REAL Or SRC2_REAL
      Shr Al, 1           ; mov bit 0 to Carry Flag , NumberB = 0
      Jc NumberBIs0       ; jump on Carry Flag

      Invoke lstrcat, Addr szBuffer, TextAddr("  +  ")
;      print chr$(" + ")
;      Invoke FpuFLtoA, Addr NumberB, 4, Addr szNumber2, SRC1_REAL
;      print ext$ (NumberB, 0, 4) ; display the X coefficient of
                                                ; quadratic equation
                                                ; to 4 decimal places
      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer
	  ;Convert the NumberB value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, Addr NumberB, Eax, ecDecimal
                                                
      Invoke lstrcat, Addr szBuffer, TextAddr(" X ")
;      print chr$(" X ")
      Jmp NextC   ; just jump
                     ;
NumberBIs0:
NextC:
      Invoke FpuComp, Addr NumberC, Offset Number0, SRC1_REAL Or SRC2_REAL
      Shr Al, 1              ; mov bit 0 to Carry Flag , NumberC = 0
      Jc NumberCIs0          ; jump on Carry Flag
      Invoke lstrcat, Addr szBuffer, TextAddr("  +  ")
;       print chr$(" + ")
;      Invoke FpuFLtoA, Addr NumberC, 4, Addr szNumber3, SRC1_REAL
;       print ext$ (NumberC, 0, 4) ; display the constant of
                                                ; quadratic equation
      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer
	  ;Convert the NumberC value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, Addr NumberC, Eax, ecDecimal
                                                ; to 4 decimal places
      Jmp EndPrint  ; just jump

NumberCIs0:
EndPrint:
      Invoke lstrcat, Addr szBuffer, TextAddr("   =  0 ")
      Invoke lstrcat, Addr szBuffer, Addr szCRLF
;       print chr$ (" = 0 ", 13, 10)

;       print chr$(13, 10, 13, 10) ; two carriage return line feeds will be
                                 ; outputted to the screen
                                     ;Get the handle to Results Static control in Eax
      Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_RESULTS
      Invoke SetWindowText, Eax, Addr szBuffer
      Ret
printQuadraticFormat EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  printTheXRoots outputs the real roots of the quadratic equation.  <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

printTheXRoots Proc Private, hWnd:HWND

;      print chr$("  Solutions for quadratic equation : ", 13, 10)
;      print chr$("--------------------------------------", 13, 10)

      Invoke printQuadraticFormat, hWnd

      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF
      Invoke lstrcat, Addr szBuffer, TextAddr("  Solutions for the quadratic equation :")
      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF
      
      Invoke lstrcat, Addr szBuffer, TextAddr(" --------------------------------------------------------")
      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

      Invoke lstrcat, Addr szBuffer, TextAddr(" ")

      Invoke lstrcat, Addr szBuffer, TextAddr(" X   =  ")
;       print chr$(" X = ")
;      Invoke FpuFLtoA, Addr _RootX0, 15, Addr szRootX0, SRC1_REAL
;       print real10$ (_RootX0)   ; print the real number of one real root
                                ; in the quadratic formula
      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer
	  ;Convert the _RootX0 value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, Addr _RootX0, Eax, ecDecimal

      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

;       print chr$(13, 10)
      Invoke lstrcat, Addr szBuffer, TextAddr("    1 ")
;       print chr$("  1 ", 13, 10, 13, 10)

	  ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

      Invoke lstrcat, Addr szBuffer, TextAddr(" ")
      Invoke lstrcat, Addr szBuffer, TextAddr(" X   =  ")
;       print chr$(" X = ")
;      Invoke FpuFLtoA, Addr _RootX1, 15, Addr szRootX1, SRC1_REAL
;       print real10$ (_RootX1)   ; print the real number of another real root
                                ; in the quadratic formula
      ;Get the address of last character of szBuffer
      Invoke lstrlen, Addr szBuffer
      Add Eax, Offset szBuffer
	  ;Convert the _RootX1 value to a decimal
	  ;string and adds it to szBuffer
      Invoke String, Addr _RootX1, Eax, ecDecimal
                                
      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

;       print chr$(13, 10)
      Invoke lstrcat, Addr szBuffer, TextAddr("    2 ")
;       print chr$("  2 ", 13, 10)
;       print chr$(13, 10)
      ;Adds a carriage return/line feed to szBuffer
      Invoke lstrcat, Addr szBuffer, Addr szCRLF

      ;Get the handle to Results Static control in Eax
      Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_RESULTS
      Invoke SetWindowText, Eax, Addr szBuffer
	Ret
printTheXRoots EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  printLinearFormat will output the format of the linear equation   <<
;<<  with the two user numbers entered.                                <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

printLinearFormat Proc Private hWnd:HWND

     ;Get the address of last character of szBuffer
     Invoke lstrlen, Addr szBuffer
     Add Eax, Offset szBuffer

	  ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF

;       print chr$(13, 10)
     Invoke lstrcat, Addr szBuffer, TextAddr(" Linear Equation :  Bx + C  =  0")
;       print chr$("Linear Equation : Bx + C ", 13, 10)

     ;Adds a carriage return/line feed to szBuffer
 	 Invoke lstrcat, Addr szBuffer, Addr szCRLF
     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF

;       print chr$(13, 10)
     Invoke lstrcat, Addr szBuffer, TextAddr(" The linear equation : ")
     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF
     
;       print chr$(" Solution for linear Equation : ", 13, 10)
     Invoke lstrcat, Addr szBuffer, TextAddr(" -------------------------------")
     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF

;       print chr$("-------------------------------", 13, 10)
     Invoke lstrcat, Addr szBuffer, TextAddr(" ")
;       print chr$(" ")
;     Invoke FpuFLtoA, Addr NumberB, 15, Addr szNumber1, SRC1_REAL
      ;Get the address of last character of szBuffer
     Invoke lstrlen, Addr szBuffer
     Add Eax, Offset szBuffer
	  ;Convert the NumberB value to a decimal
	  ;string and adds it to szBuffer
     Invoke String, Addr NumberB, Eax, ecDecimal

;       print ext$ (NumberB, 0, 4)  ; display the X coefficient of linear equation
                                   ; to 4 decimal places
     Invoke FpuComp, Addr NumberC, Offset Number0, SRC1_REAL Or SRC2_REAL
     Shr Al, 1                  ; mov bit 0 to Carry Flag , NumberC = 0
     Jc NumberCIs0              ; jump on Carry Flag
     Invoke lstrcat, Addr szBuffer, TextAddr(" X  +  ")
;       print chr$(" X + ")
;     Invoke FpuFLtoA, Addr NumberC, 15, Addr szNumber2, SRC1_REAL
      ;Get the address of last character of szBuffer
     Invoke lstrlen, Addr szBuffer
     Add Eax, Offset szBuffer
	  ;Convert the NumberC value to a decimal
	  ;string and adds it to szBuffer
     Invoke String, Addr NumberC, Eax, ecDecimal

;       print ext$ (NumberC, 0, 4) ; display the constant of linear equation to
                                  ; to 4 decimal places
     Jmp Next      ; just jump

NumberCIs0:
     Invoke lstrcat, Addr szBuffer, TextAddr(" X ")
;	   print chr$(" X ")
Next:
     Invoke lstrcat, Addr szBuffer, TextAddr("  =  0 ")

     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF
     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF

;	   print chr$(" = 0 ", 13, 10, 13, 10)
     Invoke lstrcat, Addr szBuffer, TextAddr("  Solution for the linear equation : ")
     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF
     
     Invoke lstrcat, Addr szBuffer, TextAddr(" ------------------------------------------------")
     ;Adds a carriage return/line feed to szBuffer
	 Invoke lstrcat, Addr szBuffer, Addr szCRLF
     
     Invoke lstrcat, Addr szBuffer, TextAddr(" ")

     Invoke lstrcat, Addr szBuffer, TextAddr(" X  =  ")
;       print chr$(" X = ")
;     Invoke FpuFLtoA, Addr _LinearRootX, 15, Addr szLinearRootX, SRC1_REAL
     ;Get the address of last character of szBuffer
     Invoke lstrlen, Addr szBuffer
     Add Eax, Offset szBuffer
	 ;Convert the _LinearRootX value to a decimal
	 ;string and adds it to szBuffer
;	 Invoke FpuFLtoA, Addr _LinearRootX, 15, Addr szLinearRootX, SRC1_FPU Or SRC1_REAL
     Invoke String, Addr szLinearRootX, Eax, ecDecimal

;       print real10$ (_LinearRootX)
;       print chr$(13, 10, 13, 10)
       ;print chr$(13, 10)

     ;Get the handle to Results Static control in Eax
     Invoke GetWindowItem, hWnd, IDC_QUADRATICSOLUTIONS_RESULTS
     Invoke SetWindowText, Eax, Addr szBuffer
	Ret
printLinearFormat EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateLinearRoot procedure will use NumberB and NumberC which are the  <<
;<<  numbers in a linear equation to solve for X value.                        <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateLinearRoot Proc pNumberB:DWord, pNumberC:DWord
     Local negativeNumberC:Real10

     Lea Edx, negativeNumberC  ; Edx is the pointer address of negativeNumC
     Invoke FpuChs, pNumberC, Edx, SRC1_REAL
     Cmp Eax, 0      ; compare Eax with 0
     Je _rLinearRoot  ; jump if equal to 0
     ;
     Invoke FpuDiv, Edx, pNumberB, Offset _LinearRootX, SRC1_REAL Or SRC2_REAL
                    ; EAX= 0 -> error
_rLinearRoot:
	 Ret
calculateLinearRoot EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateXRoots procedure will use the NumberA, the NumberB, and the NumberC  <<
;<<  which are the numbers in the quadratic equation be put into the quadratic     <<
;<<  formula to solve the quadratic equation for two X values.                     <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateXRoots Proc pNumberA:DWord, pNumberB:DWord, pNumberC:DWord

     ; pNumberA is a pointer to NumberA
     ; pNumberB is a pointer to NumberB
     ; pNumberC is a pointer to NumberC

     Local NumB2:Real10
     Local Num4AC:Real10
     Local NumB2_4AC:Real10
     Local RootB2_4AC:Real10
     Local Num2A:Real10
     ; NumB2 = NumberB * NumberB
     ; Num4AC = 4 * NumberA * NumberC
     ; NumB2_4AC = (NumberB * NumberB) - (4 * NumberA * NumberC)
     ; RootB2_4AC = sqrt(NumB2_4AC)
     ; Num2A = 2 * NumberA = denominator

     Local SOLX0:Real10
     Local SOLX1:Real10
     ; SOLX0 = first solution to quadratic formula
     ; SOLX1 = second solution to quadratic formula

     Lea Ebx, NumB2  ; Ebx is a pointer address of NumB2
     Invoke  FpuMul, pNumberB, pNumberB, Ebx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax   ; activate zero flag
     Jz _rRealRoots  ; jump if zero  , error -> exit
                
     Lea Ecx, Num4AC  ; Ecx is a pointer address of Num4AC
     Invoke  FpuMul, pNumberA, pNumberC, Ecx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero  , error -> exit

     Invoke  FpuMul, Ecx, Offset Number4, Ecx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero  , error -> exit

     Lea Edx, NumB2_4AC  ; Edx is a pointer address of NumB2_4AC
     Invoke  FpuSub, Ebx, Ecx, Edx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero  , error -> exit

     ; Test if NumB2_4AC >= 0
     ; ----------------------
     Invoke  FpuComp, Edx, Offset Number0, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax   ; activate zero flag
     Jz _rRealRoots ; jump if zero , error - > exit

     Test Al, 00000100B ; test bit 2 of Al, setting zero flag
     Jz @F   ; jump if zero forward to @@ , error -> exit

     ; complex roots: NumB2_4AC < 0
     ; ----------------------------
     Mov Eax, 2  ; set Eax = 2 , Complex Roots results
     Clc  ; clear carry flag
     Ret
     ;
@@:  Lea Ebx, RootB2_4AC  ; Ebx is pointer address of RootB2_4AC
     Invoke  FpuSqrt, Edx, Ebx, SRC1_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero , error -> exit

     Lea Ecx, SOLX0  ; Ecx is pointer address of SOLX0
     Invoke  FpuSub, Ebx, pNumberB, Ecx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero , error -> exit

     Lea Edx, SOLX1   ; Edx is pointer address of SOLX1
     Invoke  FpuAdd, Ebx, pNumberB, Edx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots ; jump if zero , error -> exit

     Lea Ebx, Num2A  ; Ebx is pointer address of Num2A
     Invoke  FpuMul, pNumberA, Offset Number2, Ebx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax ; activate zero flag
     Jz _rRealRoots  ; jump if zero , error -> exit

     ; SOLX0
     Invoke  FpuDiv, Ecx, Ebx, Offset _RootX0, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero , error -> exit

     ; SOLX1
     Invoke  FpuDiv, Edx, Ebx, Edx, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax ; activate zero flag
     Jz _rRealRoots   ; jump if zero , error -> exit

     Invoke  FpuMul, Edx, Offset Minus1, Offset _RootX1, SRC1_REAL Or SRC2_REAL
     Or Eax, Eax  ; activate zero flag
     Jz _rRealRoots  ; jump if zero , error -> exit
     ;
     Mov Eax, 1   ; set Eax = 1 , Real Roots results
     Clc  ; clear carry flag
     Ret
     ;
     ; EAX = 0 => Error
     ;
_rRealRoots:

     Stc  ; set carry flag
     Ret
calculateXRoots EndP